<template>
  <FormControl :id="id" :label="label" :required="required" :error="error">
    <vSelect
      v-show="!isPreview"
      :id="id"
      :options="options"
      @input="setSelected"
      :value="value"
      :placeholder="placeholder"
    >
      <template #search="{attributes, events}">
        <input
          :name="id"
          :required="!value"
          v-bind="attributes"
          v-on="events"
        />
      </template>
      <span v-if="noOptionsMessage" slot="no-options">{{
        noOptionsMessage
      }}</span>
    </vSelect>
    <Paragraph v-if="isPreview" :text="value" class="preview-text" />
  </FormControl>
</template>

<script>
import FormControl from "./FormControl";
import { isPreviewMixin } from "../../mixins/isPreview";
import Paragraph from "../Paragraph";
export default {
  name: "FormSelect",
  components: { Paragraph, FormControl },
  mixins: [isPreviewMixin],
  props: {
    id: {
      type: String,
      required: true
    },
    options: {
      type: Array,
      required: true
    },
    value: {
      type: String,
      required: true
    },
    label: String,
    noOptionsMessage: String,
    error: String,
    placeholder: {
      type: String,
      default: "Select"
    },
    required: {
      type: Boolean,
      default: true
    },
    model: {
      prop: "value",
      event: "input"
    }
  },
  methods: {
    setSelected(value) {
      this.$emit("input", value);
    }
  }
};
</script>

<style lang="scss"></style>
